unit Princ;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DateUtils, ComCtrls, StdCtrls ;

type
  TF_Princ = class(TForm)
    DTP_Debut: TDateTimePicker;
    DTP_Fin: TDateTimePicker;
    L_DateDebut: TLabel;
    L_DateFin: TLabel;
    Btn_Fermer: TButton;
    Memo1: TMemo;
    Btn_ClearMemo: TButton;
    Btn_Calculer: TButton;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure DTP_DebutChange(Sender: TObject);
    procedure DTP_FinChange(Sender: TObject);
    procedure Btn_FermerClick(Sender: TObject);
    procedure Btn_ClearMemoClick(Sender: TObject);
    Procedure List_jour_feries(_Year : Word);
    Procedure Calculer(_Year : Word);
    procedure Btn_CalculerClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  F_Princ: TF_Princ;
  JourFeries : Array[1..10] of TDateTime ;
  DateDebut , DateFin : TDateTime ;
  Valide     : Array[1..366] of Byte;
  NbJourValide : Integer ;


implementation

{$R *.dfm}


{---------------------------- Retourne La date de Paques ----------------------}
function Paques( _Year: word = 0 ): TDateTime;
// http://www.tondering.dk/claus/calendar.html
var a, b, c, d, e, mois, jour: integer;
begin
    if _Year = 0 then _Year := YearOf( Date );
    a     := _Year mod 19;
    b     := _Year div 100;
    c     := (b - (b div 4) - ((8 * b + 13) div 25) + (19 * a) + 15) mod 30;
    d     := c - (c div 28) * (1 - (c div 28) * (29 div (c + 1)) * ((21 - a) div 11));
    e     := d - ((_Year + (_Year div 4) + d + 2 - b + (b div 4)) mod 7);
    mois  := 3 + ((e + 40) div 44);
    jour  := e + 28 - (31 * (mois div 4));
    Result := EncodeDate( _Year, mois, jour );
end;
 
{------------------------ Lundi de paques -------------------------------------}
function PaquesLundi( _Year: word = 0 ): TDateTime;
begin
    Result := Paques( _Year ) + 1;
end;
 
{------------------------ Renvoi La date De Ascenssion ------------------------}
function Ascension( _Year: word = 0 ): TDateTime;
begin
    Result := Paques( _Year ) + 39;
end;
 
{------------------------ Renvoi Pentecote ------------------------------------}
function Pentecote( _Year: word = 0 ): TDateTime;
begin
    Result := Paques( _Year ) + 49;
end;
 
{--------------------------- Renvoi Lundi de Pentecote ------------------------}
function PentecoteLundi( _Year: word = 0 ): TDateTime;
begin
    Result := Paques( _Year ) + 50;
end;
 
{------------------------------ Liste des jours feris  ---------------------------}
Procedure TF_Princ.List_jour_feries(_Year : Word);
Var
   i   : Integer ;
   JourSemaine : Array[1..7] of String ;
begin
   JourSemaine[1] := 'Dimanche' ;
   JourSemaine[2] := 'Lundi' ;
   JourSemaine[3] := 'Mardi' ;
   JourSemaine[4] := 'Mercredi' ;
   JourSemaine[5] := 'Jeudi' ;
   JourSemaine[6] := 'Vendredi' ;
   JourSemaine[7] := 'Samedi' ;
   if _Year = 0 then _Year:= YearOf(Date);
      // jour de l'an
   i := 1 ;
   JourFeries[i] := EncodeDate( _Year , 1 , 1 ) ;
   Valide[1] := 0 ;
   Memo1.Lines.Add( Datetostr( JourFeries[i] )+ ' - Jour de l''an - '+ JourSemaine[DayofWeek(JourFeries[i]) ] );
      // 1er mai (fte du Travail)
   i := 2 ;
   JourFeries[i] := EncodeDate(  _Year , 5 , 1 ) ;
   Valide[DayofTheYear(JourFeries[i])] := 0 ;
   Memo1.Lines.Add( Datetostr( JourFeries[i] )+ ' - Fte du travail' );
      // 15 aot (Assomption)
   i := 3 ;
   JourFeries[i] := EncodeDate( _Year , 8 , 15 ) ;
   Valide[DayofTheYear(JourFeries[i])] := 0 ;
   Memo1.Lines.Add( Datetostr( JourFeries[i] ) + ' - Assomption');
     // 1er novembre (Toussaint)
   i := 4 ;
   JourFeries[i] := EncodeDate( _Year , 11 , 1 ) ;
   Valide[DayofTheYear(JourFeries[i])] := 0 ;
   Memo1.Lines.Add( Datetostr( JourFeries[i] ) + ' - Toussaint');
     // 25 dcembre (Nol)
   i := 5 ;
   JourFeries[i] := EncodeDate( _Year , 12 , 25 ) ;
   Valide[DayofTheYear(JourFeries[i])] := 0 ;
   Memo1.Lines.Add( Datetostr( JourFeries[i] ) + ' - Nol' );
(****************************** Ftes mobiles *********************************)
      // Pques
   i := 6 ;
   JourFeries[i] := Paques( _Year ) ;
   Valide[DayofTheYear(JourFeries[i])] := 0 ;
   Memo1.Lines.Add( Datetostr( JourFeries[i] ) + ' - Pques');
      // Lundi de Pques (lundi aprs Pques)
   i := 7 ;
   JourFeries[i] := PaquesLundi( _Year ) ;
   Valide[DayofTheYear(JourFeries[i])] := 0 ;
   Memo1.Lines.Add( Datetostr( JourFeries[i] ) + ' - Lundi de pques');
      // Ascension (6e jeudi (39j) aprs Pques)
   i := 8 ;
   JourFeries[i] := Ascension( _Year ) ;
   Valide[DayofTheYear(JourFeries[i])] := 0 ;
   Memo1.Lines.Add( Datetostr( JourFeries[i] ) + ' - Ascension');
      // Pentecte (7e dimanche (49j) aprs Pques)
   i := 9 ;
   JourFeries[i] := Pentecote( _Year ) ;
   Valide[DayofTheYear(JourFeries[i])] := 0 ;
   Memo1.Lines.Add( Datetostr( JourFeries[i] ) + ' - Pentecte');
      // Lundi de la Pentecte (lundi aprs la Pentecte)
   i := 10 ;
   JourFeries[i] := PentecoteLundi( _Year ) ;
   Valide[DayofTheYear(JourFeries[i])] := 0 ;
   Memo1.Lines.Add( Datetostr( JourFeries[i] )  + ' - Lundi de Pentecte');
end;

{------------------------------ Initialisation date dbut de priode ---------------------------}
procedure TF_Princ.DTP_DebutChange(Sender: TObject);
begin
    DateDebut := DTP_Debut.Date ;
end;

{------------------------------ Initialisation date fin de priode ---------------------------}
procedure TF_Princ.DTP_FinChange(Sender: TObject);
begin
    DateFin := DTP_Fin.Date ;
end;

{------------------------------ Quitter l'application ---------------------------}
procedure TF_Princ.Btn_FermerClick(Sender: TObject);
begin
   F_Princ.Close ;
end;

{------------------------------ Effacer Memo1 ---------------------------}
procedure TF_Princ.Btn_ClearMemoClick(Sender: TObject);
begin
   Memo1.Clear ;
end;

{------------------------------ Initialisation de la Form principale ---------------------------}
procedure TF_Princ.FormCreate(Sender: TObject);
begin
    DateDebut := DTP_Debut.Date ;
    DateFin := DTP_Fin.Date ;
end;

{------------------------------ Calcul du nombre de jours dans une anne de la priode  ---------------------------}
Procedure TF_Princ.Calculer(_Year : Word);
Var
   i   : Integer ;
   YearDebut , YearFin : Word ;
   Date1 , Date2   : TDateTime ;
   PremierDimanche : TDateTime ;
   FinAnnee        : TDateTime ;
   Dimanche        : TDateTime ;
   Rang1           : Integer ;
   NbDimanche      : Integer ;
Begin
   // Par dfaut tous les jours sont neutraliss
   For i :=  1 To 366 do  Valide[i] := 0 ;
   // dtermination des bornes de travail en fonction de DateDebut et DateFin
   YearDebut := YearOf(DateDebut)  ;
   If ( YearDebut > _Year) Then Exit ;    // Tous est invalide
   If ( YearDebut < _Year) Then Date1 := EncodeDate( _Year , 1 , 1 )
                           Else Date1 := DateDebut ;
   YearFin := YearOf(DateFin)  ;
   If ( YearFin < _Year) Then Exit ;    // Tous est invalide
   If ( YearFin > _Year) Then Date2 := EncodeDate( _Year , 12 , 31 )
                           Else Date2 := DateFin ;
   // On active les jours entre Date1 et Date2
   For i :=  DayofTheYear(Date1) To DayofTheYear(Date2) do
      Begin
         Valide[i] := 1 ;
      End ;
   // on neutralise les dimanches
       // Premier dimanche de l'anne
   Rang1 :=  DayofWeek(EncodeDate( _Year , 1 , 1 ))  ;
   If Rang1 > 1 Then Rang1 := 9 - Rang1 ;
   Rang1 := Rang1 - 1 ;
   PremierDimanche  :=  EncodeDate( _Year , 1 , 1 + Rang1 ) ;
   Memo1.Lines.Add( '===========================' );
   Memo1.Lines.Add( Datetostr( PremierDimanche )+ ' - Premier dimanche de l''anne' );
   FinAnnee := EncodeDate( _Year , 12 , 31 ) ;
   Valide[DayOfTheYear(PremierDimanche)] := 0 ;
   Dimanche := PremierDimanche +7 ;
   NbDimanche := 1 ;
   While  (Dimanche <= FinAnnee) Do
      Begin
         Valide[DayOfTheYear(Dimanche)] := 0 ;
         NbDimanche := NbDimanche + 1 ;
         Dimanche := Dimanche + 7 ;
      End ;
   Memo1.Lines.Add( '===========================' );
   Memo1.Lines.Add( IntToStr(NbDimanche)+ ' Dimanches dans l''anne' );
End ;

{------------------------------ Lancement du calcul du nombre de jours ouvrables ---------------------------}
procedure TF_Princ.Btn_CalculerClick(Sender: TObject);
Var
   i , j   : Integer ;
   YearDebut , YearFin : Word ;
   NbJourAnnee  : Integer ;
begin
   Memo1.Clear;
   Memo1.Lines.Add('=============================');
   Memo1.Lines.Add(DateToStr(DateDebut))     ;
   Memo1.Lines.Add(DateToStr(DateFin))     ;
   Memo1.Lines.Add('=============================');
   NbJourValide := 0 ;
   // dtermination des annes  parcourir en fonction de DateDebut et DateFin
   YearDebut := YearOf(DateDebut)  ;
   YearFin   := YearOf(DateFin)    ;
   If ( YearDebut <= YearFin ) Then
      Begin
         For i :=   YearDebut To YearFin Do
            Begin
               Memo1.Lines.Add(' ** Calcul anne : '+IntToStr(i))     ;
               Memo1.Lines.Add('=============================');
               Calculer(i);
               List_jour_feries(i) ;
               // Cumul des jours ouvrables
               NbJourAnnee := 0 ;
               For j := 1 To 366 Do  NbJourAnnee := NbJourAnnee + Valide[j] ;
               Memo1.Lines.Add('=============================');
               Memo1.Lines.Add(' ** ' + IntToStr(NbJourAnnee) + ' pour ouvrables dans l''anne '+IntToStr(i))     ;
               Memo1.Lines.Add('=============================');
              NbJourValide := NbJourValide + NbJourAnnee ;
            End ;
      End ;
   Memo1.Lines.Add('====================================');
   Memo1.Lines.Add(' ==> Nombre de jours ouvrables dans la priode choisie : '+IntToStr(NbJourValide) + ' jours')     ;
   Memo1.Lines.Add('====================================');
   ShowMessage(' ==> Nombre de jours ouvrables dans la priode choisie : '+Chr(10)+Chr(13)+'      '+ IntToStr(NbJourValide) + ' jours')     ;

end;
{ ========================================================================== }

end.
